

#include "XMC4800.h"                         /* XMC4500 definitions           */
#include "LED.h"

//const unsigned long led_mask= {1UL << 5}; /* GPIO P3.5 */
const unsigned long led_mask[3] = {1UL << 5, 1UL << 9};              /*  GPIO P3.5, GPIO P3.9       */

/*----------------------------------------------------------------------------
  initialize LED Pins
 *----------------------------------------------------------------------------*/
void LED_Init (void) {

  /* configure PORT P3.9 pin as output */
  PORT3->IOCR4  &=  ~(0xFFUL << 8);          /* clear P3.5 settings           */
  PORT3->IOCR4  |=   (0x80UL << 8);          /* P3.5 output push pull         */
  PORT3->PDR0   &=  ~(0x07UL << 20);          /* clear P3.5 output settings    */
  PORT3->PDR0   |=   (0x02UL << 20);          /* P3.5 output strong            */

  PORT3->IOCR8  &=  ~(0xFFUL << 8);          /* clear P3.9 settings           */
  PORT3->IOCR8  |=   (0x80UL << 8);          /* P3.9 output push pull         */
  PORT3->PDR1   &=  ~(0x07UL << 4);          /* clear P3.9 output settings    */
  PORT3->PDR1   |=   (0x02UL << 4);          /* P3.9 output strong            */

  PORT5->IOCR8  &=  ~(0xFFUL << 8);          /* clear P5.9 settings           */
  PORT5->IOCR8  |=   (0x80UL << 8);          /* P5.9 output push pull         */
  PORT5->PDR1   &=  ~(0x07UL << 4);          /* clear P5.9 output settings    */
  PORT5->PDR1   |=   (0x02UL << 4);          /* P5.9 output strong            */

  LED_Off ();                               /* switch LEDs off               */

}


/*----------------------------------------------------------------------------
  Function that turns on requested LED
 *----------------------------------------------------------------------------*/
void LED_On () {

    PORT3->OMR = led_mask[0] ;  //P3.5
    PORT3->OMR = led_mask[1] ;  //P3.9
    PORT5->OMR = led_mask[1] ;  //P5.9

}

/*----------------------------------------------------------------------------
  Function that turns off requested LED
 *----------------------------------------------------------------------------*/
void LED_Off () {

    PORT3->OMR = (led_mask[0] << 16);  //P3.5
    PORT3->OMR = (led_mask[1] << 16);  //P3.9
    PORT5->OMR = (led_mask[1] << 16);  //P5.9


}


